Use Windows.pkg
Use DFClient.pkg
Use Dfline.pkg
Use CodeSpy.pkg
Use CodeSpyStatus.vw
Use File_dlg.pkg
Use WinShell.pkg

Use cReadDirComboform.pkg

External_Function32 HtmlShellExecute "ShellExecuteA" SHELL32.DLL ;
  Handle hwnd# String lpszOp# String lpszFile# String lpszParams# ;
  String lpszDir# Integer FsShowCmd# Returns Integer  
  
Procedure StartFile global String doc#
  Integer grb#
  Handle scrhDC#
  String dir#
  Move (GetDesktopWindow()) To scrhDC# // Defined in WinUser.pkg
  Move (HtmlShellExecute(scrhDC#,"Open",doc#,"",dir#,1)) To grb#
  Procedure_Return grb#
End_Procedure

#IFNDEF xSingleViewState

Activate_View Activate_oCodeSpyView for oCodeSpyView
Object oCodeSpyView is a dbView

#ENDIF
// Note: The xSingleViewState above has been defined in the main program,
//       prior the line 'Use CodeSpy.vw'
//       
//       That will make this view work as a single view without any
//       client area for the main program. Another #IFNDEF - #ENDIF
//       can be found at the very end of this view object.
//
//       Without these we would get runtime errors at startup.
// 
    Object oMultiFileCodeSpy Is a cMultiFileCodeSpy
    End_Object

    Set Label To "CodeSpy"
    Set Size to 283 421
    Set Location To 0 0
    Set Border_Style to Border_Thick
    Set Icon to "CodeSpy.ico"

    Object oTabDialog Is a dbTabDialog
        On_Key Key_Alt+Key_F1 Send Request_Next_Tab        
        
        Set Size to 250 412
        Set Location to 1 3
        Set Border_Style to Border_Thick
        Set peAnchors to anAll

        Object oCreateHTML_tp is a dbTabPage
            Set Label To "Create HTML"

            Object oSource Is a Grid
                Set Size to 137 347
                Set Location to 25 51
                Set Line_Width To 1 0
                Set Form_Width    Item 0 To 0
                Set Header_Label 0 to "Full Source Path and FileName"
                Set Line_Width              To 1 0
                Set form_width 0 to 336
                Set peAnchors to anAll
                On_Key kCancel Send Close_Panel
                
                Procedure DoAtStartup
                    Integer i
                    For i from 0 to 19
                        Send Add_Item msg_none ""   // Allow a max. of 20 different fileSelections!
                    End   
                End_Procedure // DoAtStartup
                Send DoAtStartup
                
                Procedure Next
                    If ( (Value(Self,Current_Item(Self)) = "") and (Next_Object_ID(Self,False))) Send Activate to (Next_Object_ID(Self,False))
                    Else Forward Send Next
                End_Procedure  
                
                Procedure Exiting
                    Forward Send Exiting
                    Set Current_Item to 0
                End_Procedure   
                
            End_Object // oSource

            Object oTarget Is a Form
                Set Label to "Target Folder"
                Set Size to 13 347
                Set Location to 165 51
                Set Label_Col_Offset To 0
                Set Label_Justification_Mode To jMode_Right
                Set peAnchors to anBottomLeftRight
                On_Key kCancel Send Close_Panel    

                Procedure Previous
                    Forward Send Previous
                    Set Current_Item of (oSource(Self)) to 0    // If not everytime the last item is entered, not so fine, I think!
                End_Procedure

            End_Object // oTarget

            Object oScanDependencies Is a CheckBox
                Set Label To "Scan dependencies (Use *.PKG)"
                Set Size To 10 120
                Set Location to 182 51
                Set peAnchors to anBottomLeft
                On_Key kCancel Send Close_Panel    
            End_Object // oScanDependencies
            
            
            Object oPublicOnly Is a CheckBox
                Set Label to "Public interface only. (Only include members which contain '<public>' in the source comment)"
                Set Size to 10 344
                Set Location to 194 51
                Set peAnchors to anBottomLeft
                On_Key kCancel Send Close_Panel    
            End_Object // oScanDependencies            
            
            Object oLine Is a LineControl
                Set Size to 2 404
                Set Location to 208 0
                Set peAnchors to anBottomLeftRight
            End_Object // oLine

            Object oGenerate_bn is a Button
                Set Label To "Generate HTML Doc"
                Set Default_State To TRUE
                Set Size To 14 103
                Set Location to 215 150
                Set peAnchors to anBottomLeft
                On_Key kCancel Send Close_Panel
                
                Procedure OnClick
                  Forward Send OnClick
                  String  sSource sSourceDir sFile sDir sCSSFile
                  Integer iC hoSpy hoSrc hoID
                  
                  Move (Value(oTarget(Self),0))             to sDir 
                  Move (Value(oReadDirComboform(Self),0))   to sCSSFile
                  Move (Append(sCSSFile, ".css"))           to sCSSFile
                  
                  If (Not(Directory_Exist(sDir))) Begin
                    If (YesNo_Box("Target folder doesnt exist!\n\n"+Character(34)+sDir+Character(34)+"\n\nDo you want to create it?","Question",0)) Ne MBR_YES Procedure_Return 
                    Send Make_Directory sDir
                  End
                                   
                  Send DoCopyCSSAndHtmlFiles sDir sCSSFile
                                                     
                  Send SaveValues                           // Saves all adjustments
                  Move (oMultiFileCodeSpy(Self))            to hoSpy    // Handle to CodeSpy.
                  Set psDirectory of hoSpy                  to (Value(oTarget(Self),0))
                  Set piScanDependencies of hoSpy           to (Select_State(oScanDependencies(Self),0))
                  Set piPublisOnly       of hoSpy           to (Select_State(oPublicOnly(Self),0)) 
                  Move (oSource(Self))                      to hoSrc
                
                  Send DoInit to hoSpy
                
                  Object oFilesList Is an Array
                      Move Self   to hoID
                  End_Object
                    
                  For iC From 0 To (Item_Count(hoSrc)-1)
                        Get Value of hoSrc  item iC to sSource
                        If (Trim(sSource)) Ne "" Begin
                            If "*" In sSource Begin                                     // Neither it is a cupple of files
                                Move (Trim(sSource))    To sSource                      // Not blanks at end or begin.
                //                                move (Left(sSource,Pos("\",sSource)))   to sSourceDir   // To get the directory
                                Move (PathFromPath(sSource)+"\")          To sSourceDir
                                Move ('dir:' + sSource) To sDir                         
                                Direct_Input Channel 9 sDir                             // Start input
                                    Repeat
                                        Readln Channel 9 sFile
                                        [Not SEQEOF] If (Trim(sFile)) Ne "" If Not "[" In sFile ;
                                            Set value Of hoID Item (Item_Count(hoID)) To (sSourceDir+sFile)
                                    Until [Seqeof]
                                Close_Input
                            End
                            Else Set value Of hoID Item (Item_Count(hoID)) To sSource   // or a single file.
                        End
                  End
                
                  For iC from 0 to (Item_Count(hoID))
                    Get Value of hoID item iC to sFile
                    Send ShowInfo To (oCodeSpyStatus(Self)) sFile
                    If sFile Ne "" Send RunParseFile to hoSpy sFile
                  End             
                  
                  Send WriteHTML      to hoSpy
                  Send Destroy_Object to hoID
                  Send FillGrid   of (oClasses(oMaintain_tp(oTabDialog(Parent(Parent(Self))))))
                  Send Deactivate of (oCodeSpyStatus(Self))
                End_Procedure // OnClick
                
            End_Object // oGenerate_bn

            Object ReadHtml_bn is a Button
                Set Size to 14 85
                Set Location to 215 257
                Set Label to "Read HTML Document"
                Set peAnchors to anBottomLeft
            
                Procedure OnClick
                  Send StartFile (Value(oTarget(Self),0) + "\ClassReference.htm")                    
                End_Procedure
            
            End_Object // ReadHtml_bn

            Object oHelp_bn is a Button
                Set Location to 215 347
                Set Label to "Help"
                Set peAnchors to anBottomRight
            
                Procedure OnClick      
                    String sPath
                    Get psHelpPath of (phoWorkspace(ghoApplication)) to sPath
                    Send StartFile (sPath + "\CodeSpyInfo.htm")                    
                End_Procedure
            
            End_Object // oHelp_bn

            Object oOpenDialog is a OpenDialog 
                
                Procedure DoCallOpenDialog   
                    Integer bOpen bReadOnly iNextItem iItems iPos i
                    String sFileTitle sFileName sPath sChar
                                
                    Get Value of oTarget to sPath
                    If (sPath contains "\") Begin
                        Repeat 
                            Move (Right(sPath, 1)) to sChar
                            Move (Left(sPath, Length(sPath) -1)) to sPath
                        Until (sChar = "\")  
                        Move (sPath  + "\AppSrc") to sPath
                    End  
                    Else Move "C:\Visual DataFlex Projects" to sPath
                    
                    Get Item_Count of oSource to iItems
                    For i from 0 to (iItems -1)
                        Get Value of oSource item i to sFileName 
                        If (sFileName = "") Move i to iPos
                        If (sFileName = "") Break
                    Loop
                                    
                    Set Initial_Folder to sPath
                    Set Dialog_Caption to "Please select a source file to scan"
                    
                    Get Show_Dialog of oOpenDialog to bOpen
                    If bOpen Begin
                        Get TickReadOnly_State of oOpenDialog to bReadOnly
                        Get File_Title of oOpenDialog to sFileTitle
                        Get File_Name  of oOpenDialog to sFileName
                        If bReadOnly Append sFileName ' (Read-Only)' 
                        Delegate Send DoSetFileNames sFileName iPos
                    End
                    Else Send Info_Box "No file selected." 
                       
                End_Procedure // DoCallOpenDialog
                
            End_Object // oOpenDialog

            Object oSelect_bn is a Button
                Set Size to 14 67
                Set Location to 5 331
                Set Label to "Select Source File"
            
                Procedure OnClick
                    Send DoCallOpenDialog of oOpenDialog    
                End_Procedure
            
            End_Object // oSelect_bn

            Object oReadDirComboform is a cReadDirComboform
                Set Size to 13 100
                Set Location to 215 46
                Set Label to "Style Sheet"
                Set psExtension to "*.css"
                Set Label_Col_Offset to 0
                Set Label_Justification_Mode to JMode_Right
            End_Object // oReadDirComboform
            
            Procedure DoCopyCSSAndHtmlFiles String sDir String sCSSFile
                String sLocalPath 
                Boolean bExist
                                                                                 
                Get psHelpPath of (phoWorkspace(ghoApplication)) to sLocalPath
             
                //File_Exist (sDir + "\Index.htm") bExist
                //CopyFile ".\Help\Index.htm"    to sDir  // Index.htm???

                File_Exist (sDir + "\Classes.css") bExist
                If (bExist = False) CopyFile (sLocalPath + "\*.css")     to sDir
                File_Exist (sDir + "\CodeSpyInfo.htm") bExist
                If (bExist = False) CopyFile (sLocalPath + "\Code*.htm") to sDir 
                EraseFile (sDir + "\Classes.css")
                EraseFile (sDir + "\ClassReference.css") 
                CopyFile  (sDir + "\" + sCSSFile) to (sDir + "\Classes.css")
                CopyFile  (sDir + "\" + sCSSFile) to (sDir + "\ClassReference.css")
            End_Procedure // DoCopyCSSAndHtmlFiles
            
            Procedure DoSetFileNames String sFileName Integer iItem 
                String sTargetDir sChar
                Boolean bRemoved
                Set Value of (oSource(Self)) item iItem to sFileName
                Get Value of (oTarget(Self)) to sTargetDir
                If (sTargetDir = "") Begin 
                    Move (PathRemoveFileSpec(AddressOf(sFileName))) to bRemoved
                    Move (CString(sFileName))    to sTargetDir
                    If (sTargetDir contains "\") Begin
                        Repeat 
                            Move (Right(sTargetDir, 1)) to sChar
                            Move (Left(sTargetDir, Length(sTargetDir) -1)) to sTargetDir
                        Until (sChar = "\")  
                        Move (sTargetDir  + "\Help") to sTargetDir
                    End  
                    Set Value of (oTarget(Self)) to sTargetDir
                    Set psFilePath        of (oReadDirComboform(Self)) to sTargetDir
                    Send DoCopyCSSAndHtmlFiles sTargetDir ""
                    Send DoAddFolderFiles of (oReadDirComboform(Self))
                End
            End_Procedure // DoSetFileNames
            
            Property String psSaveFile "CodeSpy.ini"
            Procedure SaveValues
                Integer iC
                Direct_Output (psSaveFile(Self))
                    Writeln (Value(oTarget(Self),0))
                    Writeln (Value(oReadDirComboform(Self),0))
                    Writeln (Select_State(oScanDependencies(Self),0))
                    For iC From 0 To (Item_Count(oSource(Self))-1)
                        Writeln (Value(oSource(Self),iC))
                    End
                Close_Output
            End_Procedure // SaveValues    
            
            Procedure LoadValues
                Integer iC
                String  sL sFolder sStyleSheet     
                
                Direct_Input (psSaveFile(Self))
                Readln sFolder
                Set Value of             (oTarget(Self))           to sFolder
                Readln  sStyleSheet
                
                Readln sL
                Set Select_State of (oScanDependencies(Self))   to sL
                For iC from 0 to (Item_Count(oSource(Self))-1)
                    ReadLn sL
                    Set Value of (oSource(Self)) item iC        to sL
                End
                Close_Input

                Set psFilePath        of (oReadDirComboform(Self)) to sFolder 
                Set psDefaultDataVal  of (oReadDirComboform(Self)) to sStyleSheet
                Send DoAddFolderFiles of (oReadDirComboform(Self))
            End_Procedure // LoadValues
            
        End_Object    // oCreateHTML_tp

        Object oMaintain_tp is a dbTabPage
            Set Label To "Maintain Classes"
            Object oClasses Is a Grid
                Set Size to 196 395
                Set Location To 4 2

                Set Line_Width To 3 0

                Set Form_Width    Item 0 To 97
                Set Header_Label  Item 0 To "ClassName"
                
                Set Form_Width 1 to 182
                Set Header_Label  Item 1 To "SourceFile"
                
                Set Form_Width 2 to 104
                Set Header_Label  Item 2 To "Group"
                Set peAnchors to anAll
                Set peResizeColumn to rcSelectedColumn
                Set piResizeColumn to 1
                
                On_Key kCancel          Send Close_Panel
                On_Key key_shift+key_f2 Send Request_Delete
                
                Object oFileClassList Is a cFileClassList
                End_Object
                
                // Deletes a row.
                Procedure Request_Delete
                    Integer iBase iOld
                    Get Dynamic_Update_State                                To iOld
                    Set Dynamic_Update_State                                To False                    
                    Get Current_item                                        To iBase
                    Move (iBase - Mod(iBase,3))                             To iBase
                    Send Delete_Item iBase
                    Send Delete_Item iBase
                    Send Delete_Item iBase
                    Set Dynamic_Update_State                                To iOld
                End_Procedure
                
                // Saves the contents of the grid to the classlist.
                Procedure SaveGrid
                    Integer hoID iOld iC
                    String sDir sClassName sSrc
                    Get value of (oTarget(oCreateHTML_tp(Parent(Self)))) item 0  to sDir
                    Move (Trim(sDir))                                       To sDir
                    Move (oFileClassList(Self))                             To hoID
                    Set psDirectory Of hoID                                 To sDir
                    Send DoInit                                             To hoID
                    For iC From 0 To (Item_Count(Self)-1)
                        Send RegisterClass To hoID (Value(Self,iC)) (Value(Self,iC+1)) (Value(Self,iC+2))
                        Move (iC+2) To iC    // 3 Items per line
                    End
                    Send WriteClasses   To hoID
                End_Procedure                
                
                // Adds a class and its sourcefile to the grid.
                Procedure AddClass String sName String sSrc String sGrp
                    Send  Add_Item msg_None sName
                    Send  Add_Item msg_None sSrc
                    Send  Add_Item msg_None sGrp
                End_Procedure
                
                // Reads the classlist of the codespy into the grid.
                Procedure FillGrid
                    Integer hoID iOld iC
                    String sDir sClassName sSrc
                    Get Dynamic_Update_State                                To iOld
                    Set Dynamic_Update_State                                To False
                    Send Delete_Data
                    Get value of (oTarget(oCreateHTML_tp(Parent(Self)))) item 0  to sDir
                    Move (Trim(sDir))                                       To sDir
                    Move (oFileClassList(Self))                             To hoID
                    Set psDirectory Of hoID                                 To sDir
                    Send ReadClasses                                        To hoID
                    Send EnumClasses To hoID Msg_AddClass Self
                    For iC From 0 To 9
                        Send AddClass "" "" ""
                    End
                    Set Dynamic_Update_State                                To iOld
                End_Procedure  // DoFillGrid
            End_Object    // oClasses

            Object oLine Is a LineControl
                Set Size to 2 404
                Set Location to 208 0
                Set peAnchors to anBottomLeftRight
            End_Object    // oLine

            Object oSave_bn is a Button
                Set Label To "Save"
                Set Location to 215 347
                Set peAnchors to anBottomRight

                On_Key kCancel Send Close_Panel
                
                Procedure OnClick
                    Send SaveGrid To (oClasses(Self))
                End_Procedure // OnClick
            End_Object    // oSave_bn

            Object oReload_bn is a Button
                Set Label To "Reload"
                Set Location to 215 292
                Set peAnchors to anBottomRight
                On_Key kCancel Send Close_Panel
                
                Procedure OnClick
                    Send FillGrid To (oClasses(Self))
                End_Procedure // OnClick
            End_Object    // oReload_bn

        End_Object    // oMaintain_tp

    End_Object    // oTabDialog

    Procedure Activating Returns Integer
        Send LoadValues to (oCreateHTML_tp(oTabDialog(Self)))
        Send FillGrid   to (oClasses(oMaintain_tp(oTabDialog(Self))))
        Procedure_Return 0
    End_Procedure // Activating
    
    Procedure IncludeMakePath
        String sMake sOpenPath
        Get_Attribute DF_OPEN_PATH              To sOpenPath
        Get_Profile_String "DFCOMP" "MakePath"  To sMake
        Set_Attribute DF_OPEN_PATH              To (sOpenPath+";"+sMake)
    End_Procedure   
    Send IncludeMakePath

#IFNDEF xSingleViewState
End_Object    // oCodeSpyView
#ENDIF